import requests
import urllib.request
from tqdm import tqdm


def check_connection(url):
    try:
        get = requests.get(url)
        return True
    except requests.exceptions.ConnectionError:
        return False


class DownloadProgressBar(tqdm):
    def update_to(self, b=1, bsize=1, tsize=None):
        if tsize is not None:
            self.total = tsize
        self.update(b * bsize - self.n)


def download_url(url, output_path):
    with DownloadProgressBar(unit='B', unit_scale=True, miniters=1, desc=url.split('/')[-1]) as t:
        urllib.request.urlretrieve(url, filename=output_path, reporthook=t.update_to)


def getForgeCode(url, version):
    get = requests.get(url)
    server = get.json()
    code = server["forgeAvailableVersions"][version]
    return code


def getSpigotCode(url, version):
    get = requests.get(url)
    server = get.json()
    code = server['spigotAvailableVersions'][version]
    return code
